select distinct
	quote_ident(:'entry_type') as entry_type,
	quote_ident(:'db_source') as database_name,
	quote_ident(srcf.name) as db_id,
	quote_ident(concat(srcf.feature_id, '_', :'db_name', '_CHADOFUN')) as db_version,
	-- quote_ident(f.name) as name,
	-- DESCRIPTION
	quote_ident(
		concat(srcf.name, ' is a ',srcftype.name,' from ', props.species, ' (',props.common_name,')',
			case when (props.properties IS NOT NULL OR f.seqlen IS NOT NULL ) 
			then 
				concat(' and which properties are: ',
					concat_ws(', ',
						case when (srcf.seqlen IS NOT NULL AND srcf.seqlen >0)
							then concat('length = ',srcf.seqlen)
						end,
						props.properties
					)
				)
			end
		)
	) as description,
	quote_ident(concat(:'url_base', srcf.name)) as url,
	quote_ident(props.species) as species, 
	'""' as xref,
	'"'||srcftype.name||'"' as feature_type, 
	'""' as sequence_id,
	'""' as sequence_version,
	'""' as start_position,
	'""' as end_position,
	'""' as map,
	'""' as map_position,
	'""' as authority,
	'""' as trait,
	'""' as trait_id,
	'""' as environment,
	'""' as environment_id,
	'""' as statistic,
	'""' as unit,
	'""' as genotype,
	'""' as experiment_type
from 
	(
	select distinct props2.fid, string_agg(pair, ', ') as properties, concat(genus,' ',species) as species,
			org.common_name as common_name from 
		(select distinct 
			f.feature_id as fid, fpterm.name as fpname, fp.value as fpval, f.organism_id as org_id,
			CASE WHEN fp.value IS NOT NULL THEN concat(fpterm.name, ' = ', fp.value) END as pair 
		from feature f
			left join featureprop fp on f.feature_id = fp.feature_id
			left join cvterm fpterm on fp.type_id = fpterm.cvterm_id
			where f.type_id = (select cvterm_id from cvterm where name = 'polypeptide')
			order by fpterm.name, fp.value asc -- always get pairs in alphabetical order, not?! Duh!
		) as props2
		join organism org on props2.org_id = org.organism_id
		group by props2.fid, genus,species, common_name 
	) as props -- aggregate features' properties into a single column
	join feature f on props.fid=f.feature_id
	join cvterm type on f.type_id = type.cvterm_id
	join featureloc floc on floc.feature_id = f.feature_id
	join feature srcf on srcf.feature_id = floc.srcfeature_id
	join cvterm srcftype on srcf.type_id = srcftype.cvterm_id and srcftype.name != 'match_part'
	where floc.RANK = 0
;
